/*
 * Copyright (c) 2018, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.carbon.consent.mgt.core.model;

/**
 * The model representing a Address of a PII Controller
 */
public class Address {

    private String addressCountry;
    private String addressLocality;
    private String addressRegion;
    private String postOfficeBoxNumber;
    private String postalCode;
    private String streetAddress;

    public Address(String addressCountry, String addressLocality, String addressRegion, String postOfficeBoxNumber,
                   String postalCode, String streetAddress) {

        this.addressCountry = addressCountry;
        this.addressLocality = addressLocality;
        this.addressRegion = addressRegion;
        this.postOfficeBoxNumber = postOfficeBoxNumber;
        this.postalCode = postalCode;
        this.streetAddress = streetAddress;
    }

    public Address() {

    }

    public String getAddressCountry() {

        return addressCountry;
    }

    public void setAddressCountry(String addressCountry) {

        this.addressCountry = addressCountry;
    }

    public String getAddressLocality() {

        return addressLocality;
    }

    public void setAddressLocality(String addressLocality) {

        this.addressLocality = addressLocality;
    }

    public String getAddressRegion() {

        return addressRegion;
    }

    public void setAddressRegion(String addressRegion) {

        this.addressRegion = addressRegion;
    }

    public String getPostOfficeBoxNumber() {

        return postOfficeBoxNumber;
    }

    public void setPostOfficeBoxNumber(String postOfficeBoxNumber) {

        this.postOfficeBoxNumber = postOfficeBoxNumber;
    }

    public String getPostalCode() {

        return postalCode;
    }

    public void setPostalCode(String postalCode) {

        this.postalCode = postalCode;
    }

    public String getStreetAddress() {

        return streetAddress;
    }

    public void setStreetAddress(String streetAddress) {

        this.streetAddress = streetAddress;
    }
}
